org.bdgenomics.adam.rdd.variant

# VariantContextRDD

###
Related Doc: package variant

#### case class VariantContextRDD(rdd: RDD[VariantContext], sequences: SequenceDictionary, samples: Seq[Sample], headerLines: Seq[VCFHeaderLine] = DefaultHeaderLines.allHeaderLines) extends MultisampleGenomicRDD[VariantContext, VariantContextRDD] with Logging with Product with Serializable

An RDD containing VariantContexts attached to a reference and samples.

rdd

  The underlying RDD of VariantContexts.

sequences

  The genome sequence these variants were called against.

samples

  The genotyped samples in this RDD of VariantContexts.

headerLines

  The VCF header lines that cover all INFO/FORMAT fields needed to represent this RDD of VariantContexts.

Linear Supertypes
Serializable, Serializable, Product, Equals, Logging, MultisampleGenomicRDD[VariantContext, VariantContextRDD], GenomicRDD[VariantContext, VariantContextRDD], AnyRef, Any
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. VariantContextRDD
2. Serializable
3. Serializable
4. Product
5. Equals
6. Logging
7. MultisampleGenomicRDD
8. GenomicRDD
9. AnyRef
10. Any

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1. #### new VariantContextRDD(rdd: RDD[VariantContext], sequences: SequenceDictionary, samples: Seq[Sample], headerLines: Seq[VCFHeaderLine] = DefaultHeaderLines.allHeaderLines)

   rdd

     The underlying RDD of VariantContexts.

   sequences

     The genome sequence these variants were called against.

   samples

     The genotyped samples in this RDD of VariantContexts.

   headerLines

     The VCF header lines that cover all INFO/FORMAT fields needed to represent this RDD of VariantContexts.

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

4. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

5. #### def broadcastRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(VariantContext, X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(VariantContext, X), Z]

   Performs a broadcast inner join between this RDD and another RDD.

   Performs a broadcast inner join between this RDD and another RDD.

   In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

   genomicRdd

     The right RDD in the join.

   returns

     Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicRDD

6. #### def broadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Iterable[VariantContext], X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(Iterable[VariantContext], X), Z]

   Performs a broadcast inner join between this RDD and another RDD.

   Performs a broadcast inner join between this RDD and another RDD.

   In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

   genomicRdd

     The right RDD in the join.

   returns

     Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

   Definition Classes
     GenomicRDD

7. #### def buildTree(rdd: RDD[(ReferenceRegion, VariantContext)])(implicit tTag: ClassTag[VariantContext]): IntervalArray[ReferenceRegion, VariantContext]

   Attributes
     protected
   Definition Classes
     VariantContextRDD → GenomicRDD

8. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

9. #### final def eq(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

10. #### def filterByOverlappingRegion(query: ReferenceRegion): VariantContextRDD

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    Runs a filter that selects data in the underlying RDD that overlaps a single genomic region.

    query

      The region to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the query region.

    Definition Classes
      GenomicRDD

11. #### def filterByOverlappingRegions(querys: List[ReferenceRegion]): VariantContextRDD

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    Runs a filter that selects data in the underlying RDD that overlaps several genomic regions.

    querys

      The regions to query for.

    returns

      Returns a new GenomicRDD containing only data that overlaps the querys region.

    Definition Classes
      GenomicRDD

12. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

13. #### def flattenRddByRegions(): RDD[(ReferenceRegion, VariantContext)]

    Attributes
      protected
    Definition Classes
      GenomicRDD

14. #### def fullOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[VariantContext], Option[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(Option[VariantContext], Option[X]), Z]

    Performs a sort-merge full outer join between this RDD and another RDD.

    Performs a sort-merge full outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a full outer join, if a value from either RDD does not overlap any values in the other RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and values that did not overlap will be paired with a `None`.

    Definition Classes
      GenomicRDD

15. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

16. #### def getReferenceRegions(elem: VariantContext): Seq[ReferenceRegion]

    elem

      The variant context to get a reference region for.

    returns

      Returns a seq containing the position key from the variant context.

    Attributes
      protected
    Definition Classes
      VariantContextRDD → GenomicRDD

17. #### val headerLines: Seq[VCFHeaderLine]

    The VCF header lines that cover all INFO/FORMAT fields needed to represent this RDD of VariantContexts.

18. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

19. #### def isTraceEnabled(): Boolean

    Attributes
      protected
    Definition Classes
      Logging

20. #### lazy val jrdd: JavaRDD[VariantContext]

    The underlying RDD of genomic data, as a JavaRDD.

    The underlying RDD of genomic data, as a JavaRDD.

    Definition Classes
      GenomicRDD

21. #### def leftOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(VariantContext, Option[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(VariantContext, Option[X]), Z]

    Performs a sort-merge left outer join between this RDD and another RDD.

    Performs a sort-merge left outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a left outer join, all values in the right RDD that do not overlap a value from the left RDD are dropped. If a value from the left RDD does not overlap any values in the right RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the left RDD that did not overlap a key in the right RDD.

    Definition Classes
      GenomicRDD

22. #### def log: Logger

    Attributes
      protected
    Definition Classes
      Logging

23. #### def logDebug(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

24. #### def logDebug(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

25. #### def logError(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

26. #### def logError(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

27. #### def logInfo(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

28. #### def logInfo(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

29. #### def logName: String

    Attributes
      protected
    Definition Classes
      Logging

30. #### def logTrace(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

31. #### def logTrace(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

32. #### def logWarning(msg: ⇒ String, throwable: Throwable): Unit

    Attributes
      protected
    Definition Classes
      Logging

33. #### def logWarning(msg: ⇒ String): Unit

    Attributes
      protected
    Definition Classes
      Logging

34. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

35. #### final def notify(): Unit

    Definition Classes
      AnyRef

36. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

37. #### def pipe[X, Y <: GenomicRDD[X, Y], V <: InFormatter[VariantContext, VariantContextRDD, V]](cmd: String, files: Seq[String] = Seq.empty, environment: Map[String, String] = Map.empty, flankSize: Int = 0)(implicit tFormatterCompanion: InFormatterCompanion[VariantContext, VariantContextRDD, V], xFormatter: OutFormatter[X], convFn: (VariantContextRDD, RDD[X]) ⇒ Y, tManifest: ClassTag[VariantContext], xManifest: ClassTag[X]): Y

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Pipes genomic data to a subprocess that runs in parallel using Spark.

    Files are substituted in to the command with a $x syntax. E.g., to invoke a command that uses the first file from the files Seq, use $0.

    Pipes require the presence of an InFormatterCompanion and an OutFormatter as implicit values. The InFormatterCompanion should be a singleton whose apply method builds an InFormatter given a specific type of GenomicRDD. The implicit InFormatterCompanion yields an InFormatter which is used to format the input to the pipe, and the implicit OutFormatter is used to parse the output from the pipe.

    X

      The type of the record created by the piped command.

    Y

      A GenomicRDD containing X's.

    V

      The InFormatter to use for formatting the data being piped to the command.

    cmd

      Command to run.

    files

      Files to make locally available to the commands being run. Default is empty.

    environment

      A map containing environment variable/value pairs to set in the environment for the newly created process. Default is empty.

    flankSize

      Number of bases to flank each command invocation by.

    returns

      Returns a new GenomicRDD of type Y.

    Definition Classes
      GenomicRDD

38. #### val rdd: RDD[VariantContext]

    The underlying RDD of VariantContexts.

    The underlying RDD of VariantContexts.

    Definition Classes
      VariantContextRDD → GenomicRDD

39. #### def replaceRdd(newRdd: RDD[VariantContext]): VariantContextRDD

    newRdd

      The RDD of VariantContexts to replace the underlying RDD.

    returns

      Returns a new VariantContextRDD where the underlying RDD has been replaced.

    Attributes
      protected
    Definition Classes
      VariantContextRDD → GenomicRDD

40. #### def rightOuterBroadcastRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[VariantContext], X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(Option[VariantContext], X), Z]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

41. #### def rightOuterBroadcastRegionJoinAndGroupByRight[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Iterable[VariantContext], X), Z]](genomicRdd: GenomicRDD[X, Y])(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(Iterable[VariantContext], X), Z]

    Performs a broadcast right outer join between this RDD and another RDD.

    Performs a broadcast right outer join between this RDD and another RDD.

    In a broadcast join, the left RDD (this RDD) is collected to the driver, and broadcast to all the nodes in the cluster. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

42. #### def rightOuterShuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[VariantContext], X), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(Option[VariantContext], X), Z]

    Performs a sort-merge right outer join between this RDD and another RDD.

    Performs a sort-merge right outer join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is a right outer join, all values in the left RDD that do not overlap a value from the right RDD are dropped. If a value from the right RDD does not overlap any values in the left RDD, it will be paired with a `None` in the product of the join.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, and all keys from the right RDD that did not overlap a key in the left RDD.

    Definition Classes
      GenomicRDD

43. #### def rightOuterShuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(Option[VariantContext], Iterable[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(Option[VariantContext], Iterable[X]), Z]

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    Performs a sort-merge right outer join between this RDD and another RDD, followed by a groupBy on the left value, if not null.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. In the same operation, we group all values by the left item in the RDD. Since this is a right outer join, all values from the right RDD who did not overlap a value from the left RDD are placed into a length-1 Iterable with a `None` key.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD, and all values from the right RDD that did not overlap an item in the left RDD.

    Definition Classes
      GenomicRDD

44. #### val samples: Seq[Sample]

    The genotyped samples in this RDD of VariantContexts.

    The genotyped samples in this RDD of VariantContexts.

    Definition Classes
      VariantContextRDD → MultisampleGenomicRDD

45. #### def saveAsVcf(filePath: String, asSingleFile: Boolean = false, stringency: ValidationStringency = ValidationStringency.LENIENT): Unit

    Converts an RDD of ADAM VariantContexts to HTSJDK VariantContexts and saves to disk as VCF.

    Converts an RDD of ADAM VariantContexts to HTSJDK VariantContexts and saves to disk as VCF.

    filePath

      The filepath to save to.

    asSingleFile

      If true, saves the output as a single file by merging the sharded output after completing the write to HDFS. If false, the output of this call will be written as shards, where each shard has a valid VCF header. Default is false.

    stringency

      The validation stringency to use when writing the VCF.

46. #### def saveAsVcf(args: SaveArgs, sortOnSave: Boolean): Unit

    Converts an RDD of ADAM VariantContexts to HTSJDK VariantContexts and saves to disk as VCF.

    Converts an RDD of ADAM VariantContexts to HTSJDK VariantContexts and saves to disk as VCF.

    sortOnSave

      Whether to sort before saving.

47. #### val sequences: SequenceDictionary

    The genome sequence these variants were called against.

    The genome sequence these variants were called against.

    Definition Classes
      VariantContextRDD → GenomicRDD

48. #### def shuffleRegionJoin[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(VariantContext, X), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(VariantContext, X), Z]

    Performs a sort-merge inner join between this RDD and another RDD.

    Performs a sort-merge inner join between this RDD and another RDD.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space.

    Definition Classes
      GenomicRDD

49. #### def shuffleRegionJoinAndGroupByLeft[X, Y <: GenomicRDD[X, Y], Z <: GenomicRDD[(VariantContext, Iterable[X]), Z]](genomicRdd: GenomicRDD[X, Y], optPartitions: Option[Int] = None)(implicit tTag: ClassTag[VariantContext], xTag: ClassTag[X]): GenomicRDD[(VariantContext, Iterable[X]), Z]

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    Performs a sort-merge inner join between this RDD and another RDD, followed by a groupBy on the left value.

    In a sort-merge join, both RDDs are co-partitioned and sorted. The partitions are then zipped, and we do a merge join on each partition. The key equality function used for this join is the reference region overlap function. Since this is an inner join, all values who do not overlap a value from the other RDD are dropped. In the same operation, we group all values by the left item in the RDD.

    genomicRdd

      The right RDD in the join.

    returns

      Returns a new genomic RDD containing all pairs of keys that overlapped in the genomic coordinate space, grouped together by the value they overlapped in the left RDD..

    Definition Classes
      GenomicRDD

50. #### def sort(): VariantContextRDD

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    Sorts our genome aligned data by reference positions, with contigs ordered by index.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Does not support data that is unaligned or where objects align to multiple positions.

    See also

      sortLexicographically

51. #### def sortLexicographically(): VariantContextRDD

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    Sorts our genome aligned data by reference positions, with contigs ordered lexicographically.

    returns

      Returns a new RDD containing sorted data.

    Definition Classes
      GenomicRDD
    Note

      Does not support data that is unaligned or where objects align to multiple positions.

    See also

      sort

52. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

53. #### def toGenotypeRDD: GenotypeRDD

    returns

      Returns a GenotypeRDD containing the Genotypes in this RDD.

54. #### def toVariantRDD: VariantRDD

    returns

      Returns the Variants in this RDD.

55. #### def transform(tFn: (RDD[VariantContext]) ⇒ RDD[VariantContext]): VariantContextRDD

    Applies a function that transforms the underlying RDD into a new RDD.

    Applies a function that transforms the underlying RDD into a new RDD.

    tFn

      A function that transforms the underlying RDD.

    returns

      A new RDD where the RDD of genomic data has been replaced, but the metadata (sequence dictionary, and etc) is copied without modification.

    Definition Classes
      GenomicRDD

56. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

57. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

58. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

### Inherited from Serializable

### Inherited from Product

### Inherited from Equals

### Inherited from Logging

### Inherited from MultisampleGenomicRDD[VariantContext, VariantContextRDD]

### Inherited from GenomicRDD[VariantContext, VariantContextRDD]

### Inherited from AnyRef

### Inherited from Any

### Ungrouped